﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Interop;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Charts;
using Infragistics.Windows;

namespace ChartInfoStrips
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            Loaded += MainWindow_Loaded;
        }

        void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("XAxis", typeof(string));
            dt.Columns.Add("YAxis", typeof(double));

            dt.Rows.Add("-5", 0.0025);
            dt.Rows.Add("-4", 0.0015);
            dt.Rows.Add("-3", 0.001);
            dt.Rows.Add("-2", 0.0075);
            dt.Rows.Add("-1", 0.035);

            dt.Rows.Add("1", 0.0105);
            dt.Rows.Add("2", 0.0105);
            dt.Rows.Add("3", 0.006);
            dt.Rows.Add("4", 0.005);
            dt.Rows.Add("5", 0.007);
            dt.Rows.Add("6", 0.009);
            dt.Rows.Add("7", 0.0085);
            dt.Rows.Add("8", 0.009);

            dt.Rows.Add("-4", 0.007);
            dt.Rows.Add("-3", 0.01);
            dt.Rows.Add("-2", 0.013);
            dt.Rows.Add("-1", 0.015);

            dt.Rows.Add("OE", 0.014);

            dt.Rows.Add("1", 0.0095);
            dt.Rows.Add("2", 0.01);

            dt.Rows.Add("-6", 0.01);
            dt.Rows.Add("-5", 0.01);
            dt.Rows.Add("-4", 0.01);
            dt.Rows.Add("-3", 0.01);
            dt.Rows.Add("-2", 0.01);
            dt.Rows.Add("-1", 0.01);

            dt.Rows.Add("1", 0.01);
            dt.Rows.Add("2", 0.01);
            dt.Rows.Add("3", 0.01);
            dt.Rows.Add("4", 0.01);

            (xamDataChart.Axes[2] as CategoryXAxis).ItemsSource = dt.DefaultView;

            (xamDataChart.Series[0] as LineSeries).ItemsSource = dt.DefaultView;
        }

        private void xamDataChart_RefreshCompleted(object sender, EventArgs e)
        {
            LineSeries series = xamDataChart.Series[0] as LineSeries;
            if (series.RootCanvas != null)
            {
                HorizontalAxisLabelPanel axisPanel = (HorizontalAxisLabelPanel)Utilities.GetDescendantFromType<HorizontalAxisLabelPanel>(xamDataChart, false, SearchHorizontalAxisCallback);
                
            }
        }

        private bool SearchHorizontalAxisCallback(HorizontalAxisLabelPanel dependencyObject)
        {
            LineSeries series = xamDataChart.Series[0] as LineSeries;
            if (series.RootCanvas != null)
            {
                double pixel = yAxis.ScaleValue(0.0);

                // get the handle of the window
                HwndSource windowhandlesource = PresentationSource.FromVisual(this) as HwndSource;

                // work out the current screen's DPI
                Matrix screenmatrix = windowhandlesource.CompositionTarget.TransformToDevice;
                double dpiX = screenmatrix.M11;
                double dpiY = screenmatrix.M22;

                double marginAdjustment = (series.RootCanvas.ActualHeight - pixel) * 2.0 - 28;
                dependencyObject.Margin = new Thickness(0, -(marginAdjustment / dpiY), 0, 0);
            }

            return false;
        }
    }
}
